=begin
Copyright 2009, Chris Glasier Code adviser:Jim Foltz

=end


require 'sketchup.rb'

# I like to see the menu at the top so I know where the main entry point
# for the script is. -- Jim

if (not file_loaded?("nsnSketchupApi.rb"))
    UI.menu("Plugins").add_item("API" ){ NsnSketchupApiMod.start }
end

module NsnSketchupApiMod

    def NsnSketchupApiMod.start
	
		Sketchup.send_action "selectSelectionTool:"
		
		@dlg = UI::WebDialog.new("Sketchup API nset device", true, "deviceAPI", 230, 345, 0, 0, true)
        subDir = "nset/Sketchup/Api/"
        fileName = "device.htm"
        @dlg.set_file File.join(File.dirname(__FILE__), subDir+fileName)

		@dlg.add_action_callback("send_json") { |d, a|
			js_func, *params = a.split(';')
			filename = params[0]
			@json = load_json(filename)
			script = %^ #{js_func}('#{@json}'); ^
			d.execute_script(script)
		}
		
		@dlg.add_action_callback("apimDeviceOpen") {|d, p|
			a = p.split(",")
			@device = a[0]
			@pair = a[1]
			eval a[0] + ".start"
		}
				
        @dlg.show{}
		
		def load_json(file)
			subDir = "nset/Sketchup/Api/"
			path = File.join(File.dirname(__FILE__), subDir, file)
			puts "loading:#{path}"
            json = IO.read(File.join(File.dirname(__FILE__), subDir, file))
		end
		
		def self.sendJson(device)
			device.receiveJson(@json)
		end
		
		@pair = 1
		
		def self.sendPair(device)
			device.receivePair(@pair)
		end

    end # def nsnSketchupApiMod.start

end # module nsnSketchupApiMod

file_loaded("nsnSketchupApi.rb")
